import { Ref, UnwrapRef, UnwrapNestedRefs } from '@vue/runtime-core';

declare type ReturnedSetup<T> = T extends Readonly<Array<any>> ? T : T extends Ref ? UnwrapRef<T> : UnwrapNestedRefs<T>;
declare const getState: <T extends unknown>(setup: T) => ReturnedSetup<T>;
declare function useSetup<State, Props = {}>(fn: (props: Props) => State, ReactProps?: Props): ReturnedSetup<State>;
declare function defineComponent<PropsType = {}, State = {}>(setupFunction: (props: PropsType) => State, renderFunction?: (state: ReturnedSetup<State>, props: PropsType) => JSX.Element): (props: PropsType) => JSX.Element;
declare function createSetup<PropsType, State>(setupFunction: (props: PropsType) => State): (props: PropsType) => ReturnedSetup<State>;
declare const onPropsUpdated: <Props extends Record<any, any>>(fn: (newProps: Props) => void) => void;
declare const useProps: <Props extends Record<any, any>>(props: Props) => [Props] extends [Ref<any>] ? Props : Ref<UnwrapRef<Props>>;
declare function ReactivueProvider({ plugins, children }: {
    plugins?: any[];
    children?: JSX.Element | JSX.Element[];
}): JSX.Element;

export { ReactivueProvider, createSetup, defineComponent, getState, onPropsUpdated, useProps, useSetup };
